
var pi, i, pi_hat, sdiff, lambda_hat,
    bh,tau,
    v_tau,v_i,g;

varexo eps_vtau,eps_vi, eps_g;

parameters  beta, sigma,rho_i,phi_pi,k_tau1,delta,
            alpha_g,alpha_d,alpha1,alpha2,alpha3,psi,gamma1, gamma2,
            rho_vtau,rho_vi, rho_g,
            sigma_vtau,sigma_vi, sigma_g,
            tau_ss,c_ss,y_ss,g_ss,bh_bar,i_ss,
            bh_ss,rho_tau,ab;

sigma = 1; 
y =1; 

rho_i = 0;
rho_tau = 0.90;  //0.9 (0.25)
phi_pi = 10;    
k_tau1 = 0.25; 

beta = 0.9901; 
alpha_g = 0.22; 
alpha_d = 0.4; 
alpha1 = 2;
alpha2 = -1; 
alpha3 = 2; 
psi = 1.3e-3; 
delta = 0; 

rho_vtau =  0;  
sigma_vtau = 0; 

rho_vi =  0;  
sigma_vi = 0.01; 

rho_g = 0.9; 
sigma_g = 0; 

ab = 0.9985;
eta = 0.4;
y_ss = y; 
g_ss = alpha_g*y; 
c_ss= y_ss - g_ss; 
bh_bar = alpha_d*y_ss; 
bh_ss = bh_bar; 

uc = ((ab*c_ss^((eta-1)/eta) + (1-ab)*bh_ss^((eta-1)/eta))^(eta/(eta-1)))^(-sigma)*(ab*c_ss^((eta-1)/eta) + (1-ab)*bh_ss^((eta-1)/eta))^(1/(eta-1))*ab*c_ss^(-1/eta); 
ub = ((ab*c_ss^((eta-1)/eta) + (1-ab)*bh_ss^((eta-1)/eta))^(eta/(eta-1)))^(-sigma)*(ab*c_ss^((eta-1)/eta) + (1-ab)*bh_ss^((eta-1)/eta))^(1/(eta-1))*(1-ab)*bh_ss^(-1/eta);
ubb = (1/eta - sigma)*((ab*c_ss^((eta-1)/eta) + (1-ab)*bh_ss^((eta-1)/eta))^(eta/(eta-1)))^(2/eta-sigma)*(1-ab)^2*bh_ss^(-2/eta) - (1/eta)*((ab*c_ss^((eta-1)/eta) + (1-ab)*bh_ss^((eta-1)/eta))^(eta/(eta-1)))^(1/eta-sigma)*(1-ab)*bh_ss^(-(1+eta)/eta);
ucb = (1/eta - sigma)*((ab*c_ss^((eta-1)/eta) + (1-ab)*bh_ss^((eta-1)/eta))^(eta/(eta-1)))^(2/eta-sigma)*(1-ab)*bh_ss^(-1/eta)*ab*c_ss^(-1/eta);



psi_h = ub/uc; 
i_ss = (1-psi_h)/beta -1; 
tau_ss = i_ss*bh_bar+g_ss; 

gamma1 = -bh_ss/(beta*(1+i_ss)*uc)*(ubb -ub*ucb/uc); 
gamma2 = ucb*bh_ss/uc; 

gamma_bh = gamma1; 

theta = (1+i_ss)*(1+gamma1+gamma2); 
theta2 = 1 + (1+i_ss)*gamma2; 

rho_bar = (k_tau1*(k_tau1 - theta) + (k_tau1 + theta)*theta2 + 2*sqrt(k_tau1*theta*theta2*(k_tau1 - theta + theta2)))/(k_tau1 + theta2)^2; 
kbar = (theta + theta2*rho_tau - 2*sqrt(theta*theta2*rho_tau))/(1-rho_tau); 

LHS = theta + 2*theta2*rho_tau - 2*sqrt(theta*theta2*rho_tau) + 2*theta2*rho_tau*(kbar); 
LHS2 = (1-rho_tau)*theta2*rho_tau - (1-rho_tau)*rho_tau*sqrt(theta*theta2) + theta2*theta*rho_tau + theta2^2*rho_tau - 2*theta2*rho_tau^2*sqrt(theta*theta2); 

LHS =gamma1*( - theta*theta2*rho_tau + ( - theta2*rho_tau + 2*sqrt(theta*theta2*rho_tau))*((-1 + theta2)*rho_tau + phi_pi)) + gamma2*(i_ss*(-theta2*rho_tau + 2*sqrt(theta*theta2*rho_tau))*(rho_tau - phi_pi)+2*theta*sqrt(theta*theta2*rho_tau)*phi_pi - theta*theta2*rho_tau*(1+4*phi_pi)+theta2*rho_tau*(-theta2*rho_tau + 2*sqrt(theta*theta2*rho_tau)*(1+phi_pi))); 

model (linear);

// Equations 
0 = i - pi(+1) - (gamma1+gamma2)*bh + gamma2*bh(+1); 
bh + (tau_ss/bh_ss)*tau + (1+i_ss)*pi = (1+i_ss)*(bh(-1) + i(-1)) + (g_ss/bh_ss)*g; 
tau = rho_tau*tau(-1) + (1-rho_tau)*(bh_bar/tau_ss)*k_tau1*bh(-1) + v_tau; 
i = rho_i*i(-1) +(1-rho_i)*phi_pi*pi + v_i; 
pi_hat = pi(+1); 

lambda_hat = -gamma1*bh;
sdiff = lambda_hat + i; 

v_tau = rho_vtau*v_tau(-1) + eps_vtau; 
v_i = rho_vi*v_i(-1) + eps_vi; 
g = rho_g*g(-1) + eps_g; 

end;

initval;
pi = 0; 
i = 0; 
bh=0; 
tau = 0; 
end;

steady; 

model_diagnostics; 
check; // Checks stability of the system

shocks;

var eps_vtau = sigma_vtau^2; 
var eps_vi = sigma_vi^2; 
var eps_g = sigma_g^2; 


end;

stoch_simul(irf = 60, order = 1, nograph);
//noprint; - this will stop any printing to the display  
//nograph - this will stop the generation of graphs. 
